=== debian/changelog ===
ros-galactic-rmf-demos-maps (1.3.2-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Aaron Chong <aaron@openrobotics.org>  Wed, 01 Dec 2021 06:52:51 -0000
