=== debian/control ===
Source: ros-galactic-rmf-demos-maps
Section: misc
Priority: optional
Maintainer: Aaron Chong <aaron@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-rmf-building-map-tools, ros-galactic-ros2run, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rmf-demos-maps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-ros-workspace
Description: A package containing demo maps for rmf
